
ReadmeGeneratorTest:
  variables:
    LOCAL_COMPOSE: "docker-compose -f ./docker-compose.yml"
    REPO_NAME: $CI_PROJECT_NAME
    GIGADB_ENV: dev
    PROJECT_VARIABLES_URL: "https://gitlab.com/api/v4/projects/gigascience%2Fforks%2F$REPO_NAME/variables"
    MISC_VARIABLES_URL: "https://gitlab.com/api/v4/projects/gigascience%2Fcnhk-infra/variables"
    GROUP_VARIABLES_URL: "https://gitlab.com/api/v4/groups/gigascience/variables?per_page=100"
    FORK_VARIABLES_URL: "https://gitlab.com/api/v4/groups/3501869/variables"
    GIGADB_COMPOSE_PROJECT_NAME: $CI_PROJECT_NAME
  stage: test
  artifacts:
    paths:
      - .env
      - .secrets
      - gigadb/app/tools/readme-generator/runtime/logs/app.log
      - gigadb/app/tools/readme-generator/tests/_output
      - gigadb/app/tools/readme-generator/config/params.php
      - gigadb/app/tools/readme-generator/composer.json
      - gigadb/app/tools/readme-generator/composer.lock
      - gigadb/app/tools/readme-generator/tests/functional.suite.yml
      - gigadb/app/tools/readme-generator/tests/unit.suite.yml
      - gigadb/app/tools/readme-generator/.env
      - gigadb/app/tools/readme-generator/.secrets
      - gigadb/app/tools/readme-generator/.project_var
      - gigadb/app/tools/readme-generator/.project_var_raw1
      - gigadb/app/tools/readme-generator/.project_var_raw2
      - gigadb/app/tools/readme-generator/.project_vars.json
    when: always
    expire_in: 1 week
  script:
    # Need GigaDB images to provide database
    - env | grep "^HOME_URL" >> $APPLICATION/.env
    - env | grep "^GIGADB_" >> $APPLICATION/.secrets
    - docker pull registry.gitlab.com/$CI_PROJECT_PATH/application:latest || true
    - docker pull registry.gitlab.com/$CI_PROJECT_PATH/test:latest || true
    - docker pull registry.gitlab.com/$CI_PROJECT_PATH/console:latest || true
    - docker pull registry.gitlab.com/$CI_PROJECT_PATH/web:latest || true
    - pwd
    - ./up.sh
    - cp .secrets gigadb/app/tools/readme-generator/
    - cp .env gigadb/app/tools/readme-generator/
    - echo $APPLICATION
    - pwd
    - cd gigadb/app/tools/readme-generator
    - $LOCAL_COMPOSE run --rm configure
    - $LOCAL_COMPOSE run --rm tool composer install
    - $LOCAL_COMPOSE run --rm tool ./vendor/bin/codecept build
    - sleep 5
    - $LOCAL_COMPOSE ps
    - $LOCAL_COMPOSE run --rm tool ./vendor/bin/codecept run tests/unit
    - $LOCAL_COMPOSE run --rm tool ./vendor/bin/codecept run tests/functional
  needs: ["container_scanning","semgrep-sast"]
  environment:
    name: dev
